/*
 * GoNNThread.java
 * 
 * Copyright 2012 tinno <tinno@ubuntu>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */

import org.encog.Encog;
import org.encog.neural.networks.BasicNetwork; 
import org.encog.neural.data.*;
import org.encog.neural.data.basic.*;
import org.encog.ml.data.MLData;


public class GoNNThread extends Thread {
	Robot robot;
	boolean alive = true;
	BasicNetwork network;
	
	GoNNThread(Robot robot) {
		this.robot = robot;
		network = robot.getNN();
	}
	
	public void run() {
		while (alive) {
			goWithNN();
		}
	}
	
	private void goWithNN() {
		MLData outputData;
		BasicNeuralData inputData = new BasicNeuralData(robot.normalizedSensorsValues());
		
		outputData = network.compute(inputData);
		
		robot.turn(robot.denormalizeSpeed(outputData.getData(0)), robot.denormalizeSpeed(outputData.getData(1)));
	}
	
	public void stopNN() {
		alive = false;
	}
}

