//~ package org.encog.examples.neural.csv;

import org.encog.Encog;
import org.encog.ml.data.MLDataSet;
import org.encog.neural.networks.BasicNetwork;
import org.encog.util.csv.CSVFormat;
import org.encog.util.simple.EncogUtility;
import org.encog.util.simple.TrainingSetUtil;
import java.io.Writer;

/*
 * Robot.java
 *
 * Created on July 27, 2001, 11:06 AM
 */

/**
 *
 * @author  Steve Perretta
 * @version
 *  
 */

import java.io.*;

public class Robot1 extends Thread {
   /* Changing the following fields is not recommended.
    * The variable types should NOT be altered, but if
    * you decide to change the variable names be sure to
    * change all occurences throughout the code. 
    */
    private CurrentRobotState currentData;
    private MessagePasser     messagePasser;
    private Sensor[]          sensors; 
    private Motor             motorState;
    private int               gripperState;
    private int               armState;
    private boolean           objPresent;
    private boolean           active;

    // Add your own fields here....
    private int maxDistance = 700;
    private int forwardSpeed = 5;
    private int turnSpeed = 3;
    private int poc = 0;

   
    /** Constructor -- DO NOT MODIFY 
     */
    public Robot1(CurrentRobotState data, MessagePasser ma) {
        currentData = data;
        messagePasser = ma;
        active = true;
		
    } 

    /** This method should be called from the run() method - before
      * entering the while loop. These assignments cannot be made in the
      * constructor (?)
      */
    private void getRobotObjects() {
        sensors  = currentData.getSensorValues();
        motorState = currentData.getMotorState();
    }   
    
    /** Essentially a "wrapper" that sets the foreward speed 
     */
    private void forward() {
        motorState.setMotorSpeeds(forwardSpeed, forwardSpeed);
    }
    
    private void backward() {
        motorState.setMotorSpeeds(-forwardSpeed, -forwardSpeed);
    }
    
    /** Another "wrapper" method for setting turns
     */
    private void turn(int left, int right) {
        motorState.setMotorSpeeds(left, right);
    }
    
    /*  Terminates this thread. Called from the main program. 
     *    --- DO NOT REMOVE ---   
     */
    public void killControl() {
        active = false;
    }
       
    public double normalizeSpeed(int speed) {
		return speed / (double) forwardSpeed;
	}
	
	public double normalizeSensorValue(int value) {
		double maxValue = 1023.0;
		
		return value / maxValue;
	}

    public void go() {
		final BasicNetwork network = EncogUtility.simpleFeedForward(2, 4,
					0, 1, true);
    }
        
    public void run() {
        getRobotObjects();  // always call this !
        while(active) {
			go();
        }
    }
}


