import java.util.HashMap;
import java.util.Iterator;

public class RobotHashMap<K,V> extends HashMap<K,V> {
	int difference = 5, limit = 5000, underMaxDistance = 0, overMaxDistance = 0, maxDistance = 700;
	
	public boolean containsKey(int[] elem) {
		if (!inLimit(elem)) {
			return true;
		}
		
		for (K k : super.keySet()) {
			if (equals(elem, (int[]) k)) 
				return true;
		}
				
		return false;
	}
		
	private boolean equals(int[] a, int[] b) {
		boolean result = true;
				
		for (int i = 0; i < a.length; i++) {
			result &= inRange(a[i], b[i]);
		}
		
		return result;
	}
	
	private boolean inRange(int a, int b) {
		return Math.abs(a-b) <= difference;
	}
	
	private boolean isUnderMaxDistance(int[] a) {
		boolean result = true;
		
		for (int dist : a) {
			result &= (dist < maxDistance);
		}
		
		return result;
	}
	
	private boolean checkMaxDistance(int[] a) {
		if (isUnderMaxDistance(a)) {
			underMaxDistance++;
			return (underMaxDistance < limit) ? true : false;
		} else {
			overMaxDistance++;
			return (overMaxDistance <= limit+1) ? true : false;
		}
	}
	
	private boolean inLimit(int[] a) {
		return checkMaxDistance(a);
	}
	
	public void setDifference(int difference) {
		this.difference = difference;
	}
}

