import java.io.*;
/*
 * Robot.java
 *
 * Created on July 27, 2001, 11:06 AM
 */

/**
 *
 * @author  steve
 * @ "starter kit" for homework #1
 * 
 */

/** This is a "template" Robot.java file. Use the Example_Robot.java file
 *  as a reference: this contains example methods, and defines the methods
 *  you will need to call to poll the robot's sensors, etc. Add your own
 *  methods and data fields to this file. When you're ready to test, just 
 *  compile this file (i.e. type: javac Robot.java), and copy the resulting
 *  Robot.class file to the directory containing the programs .class files.
 */
public class Robot extends Thread {
     // Do NOT Modify these fields
    private CurrentRobotState currentData;
    private MessagePasser messagePasser;
    private Sensor[] sensors; 
    private Motor    motorState;
    private int gripperState;
    private int armState;
    private int resistivity;
    private boolean objPresent;
    private boolean active;

    // Add your own fields here....
    private int distThreshold = 600; 
    private boolean done = false;    // added to terminate I/O loop
   
    /** Creates new Robot */
    public Robot(CurrentRobotState data, MessagePasser mp) {
        currentData = data;
        messagePasser = mp;
        active = true;
    }    
    
    private void getRobotObjects() {
        sensors  = currentData.getSensorValues();
        motorState = currentData.getMotorState();
    }
    
    public void killControl() {
        active = false;
    }
    
    /* Add your own methods here.... */
    
    
    /** This is an example method that interprets the input string and
     *  sets the motors accordingly. This is only an example, so once you
     *  grasp whats going on, feel free to change things. For example, you can
     *  use longer command names, speed otions, etc.. You obviously have
     *  to fill in the rest, depending on how many commands you want. You will
     *  also note that timing, testing wheel positions (to see if the robot is
     *  stuck), and any other code pertaining to specific aspects of this
     *  homework assignment have been omitted...these you'll have to figure out
     *  on your own ;-)   (see Example_Robot.java)
     */
    private void execCommand(String command) {
        if(command.equals("f")) { 
            motorState.setMotorSpeeds(5, 5);
            messagePasser.postMessage("forward");
            return;
        }
        else if(command.equals("s")) {
            motorState.setMotorSpeeds(0, 0);
            messagePasser.postMessage("stop");
            return;
        }
        else if(command.equals("tl")) {
            motorState.setMotorSpeeds(-5, 5);
            messagePasser.postMessage("turn");
            return;
        }
        else if(command.equals("tr")) {
            motorState.setMotorSpeeds(5, -5);
            messagePasser.postMessage("turn");
            return;
        }
        else if(command.equals("b")) {
            motorState.setMotorSpeeds(-5, -5);
            messagePasser.postMessage("back");
            return;
        }
        else if(command.equals("ad")) {
            currentData.setArmState(CurrentRobotState.ARM_DOWN);
            messagePasser.postMessage("arm down");
            return;
        }
        else if(command.equals("au")) {
            currentData.setArmState(CurrentRobotState.ARM_UP);
            messagePasser.postMessage("arm up");
            return;
        }
        else if(command.equals("gc")) {
            currentData.setGripperState(CurrentRobotState.GRIP_CLOSED);
            messagePasser.postMessage("gripper closed");
            return;
        }
        else if(command.equals("go")) {
            currentData.setGripperState(CurrentRobotState.GRIP_OPEN);
            messagePasser.postMessage("gripper open");
            return;
        }
        else if(command.equals("q")) {
            done = true;
            messagePasser.postMessage("quit");
        }
    }
    
    public void run() {
        // these are specific to this assignment: for I/O processing
        String input = null;
        
        getRobotObjects(); // always call this !!

        while(active) {
            // Main I/O processing loop
            while(!done) {
                if(!active) break;
                input = messagePasser.getMessage();
                if(input != null)
                    execCommand(input.toLowerCase());
            } // while(!done)
        }
    }
    
}


