/*
 * Robot.java
 *
 * Created on July 27, 2001, 11:06 AM
 */

/**
 *
 * @author  Steve Perretta
 * @version
 *  
 */
  

public class Robot extends Thread {
   /* Changing the following fields is not recommended.
    * The variable types should NOT be altered, but if
    * you decide to change the variable names be sure to
    * change all occurences throughout the code. 
    */
    private CurrentRobotState currentData;
    private MessagePasser     messagePasser;
    private Sensor[]          sensors; 
    private Motor             motorState;
    private int               gripperState;
    private int               armState;
    private boolean           objPresent;
    private boolean           active;

    // Add your own fields here....
    private int maxDistance = 1000;
    private int forwardSpeed = 10;
    private int turnSpeed = 10;

   
    /** Constructor -- DO NOT MODIFY 
     */
    public Robot(CurrentRobotState data, MessagePasser ma) {
        currentData = data;
        messagePasser = ma;
        active = true;
    } 

    /** This method should be called from the run() method - before
      * entering the while loop. These assignments cannot be made in the
      * constructor (?)
      */
    private void getRobotObjects() {
        sensors  = currentData.getSensorValues();
        motorState = currentData.getMotorState();
    }   
    
    /** Essentially a "wrapper" that sets the foreward speed 
     */
    private void forward() {
        motorState.setMotorSpeeds(forwardSpeed, forwardSpeed);
    }
    
    /** Another "wrapper" method for setting turns
     */
    private void turn(int left, int right) {
        motorState.setMotorSpeeds(left, right);
    }
    
    /*  Terminates this thread. Called from the main program. 
     *    --- DO NOT REMOVE ---   
     */
    public void killControl() {
        active = false;
    }
    
    public boolean isNear(int dist) {
    	return dist < maxDistance;
    }
    
    public boolean leftSideIsNear() {
    	return (isNear(sensors[0].getDistValue()) || isNear(sensors[0].getDistValue()) || isNear(sensors[0].getDistValue()));
    }
    
    public boolean rightSideIsNear() {
    	return (isNear(sensors[3].getDistValue()) || isNear(sensors[4].getDistValue()) || isNear(sensors[5].getDistValue()));
    }

    public void go() {
    	if (leftSideIsNear()) {
    		turn(turnSpeed, -turnSpeed);
    		return;
    	}
    	if (rightSideIsNear()) {
    		turn(-turnSpeed, turnSpeed);
    		return;
    	}
    	forward();
    }
        
    public void run() {

        getRobotObjects();  // always call this !
        
        while(active) {
            go();
        }
    }
}


